var sVersionPref = "live";
var RefGrabIt = new Object();
RefGrabIt.MIMEHandler = new function() {
	var on = false;
}
RefGrabIt.MIMEHandler.URIContentListener = new function() {
	this.desiredContentTypes = ["application/x-endnote-refer","application/x-research-info-systems","text/ris"];
	this.QueryInterface = QueryInterface;
	this.canHandleContent = canHandleContent;
	this.doContent = doContent;
	this.isPreferred = isPreferred;
	this.onStartURIOpen = onStartURIOpen;
	
	function QueryInterface(iid) {
		if(iid.equals(Components.interfaces.nsISupports)
		   || iid.equals(Components.interfaces.nsISupportsWeakReference)
		   || iid.equals(Components.interfaces.nsIURIContentListener)) {
			return this;
		}
		throw Components.results.NS_ERROR_NO_INTERFACE;
	}
	function canHandleContent(contentType, isContentPreferred, desiredContentType) {
		if(RefGrabIt.inArray(contentType, this.desiredContentTypes)) {
			return true;
		}
		return false;
	}
	function doContent(contentType, isContentPreferred, request, contentHandler) {
		contentHandler.value = new RefGrabIt.MIMEHandler.StreamListener(request, contentType);
		return false;
	}
	function isPreferred(contentType, desiredContentType) {
		if(RefGrabIt.inArray(contentType, this.desiredContentTypes)) {
			return true;
		}
		return false;
	}
	function onStartURIOpen(URI) {
		return false;
	}
}

RefGrabIt.MIMEHandler.Observer = new function() {
	this.desiredContentTypes = ["application/x-endnote-refer","application/x-research-info-systems","text/ris"];
	this.observe = function(channel) {
		channel.QueryInterface(Components.interfaces.nsIRequest);
		if(channel.loadFlags & Components.interfaces.nsIHttpChannel.LOAD_DOCUMENT_URI) {
			channel.QueryInterface(Components.interfaces.nsIHttpChannel);
			try {
				var contentType = channel.getResponseHeader("Content-Type").toLowerCase();
				if(RefGrabIt.inArray(contentType, this.desiredContentTypes))
					channel.setResponseHeader("Content-Disposition", "", false);
			} catch(e) {}
		}
	}
}

RefGrabIt.MIMEHandler.StreamListener = function(request, contentType) {
	this._request = request;
	this._contentType = contentType
	this._readString = "";
	this._scriptableStream = null;
	this._scriptableStreamInput = null
}
RefGrabIt.MIMEHandler.StreamListener.prototype.QueryInterface = function(iid) {
	if(iid.equals(Components.interfaces.nsISupports)
	   || iid.equals(Components.interfaces.nsIRequestObserver)
	   || iid.equals(Components.interfaces.nsIStreamListener)) {
		return this;
	}
	throw Components.results.NS_ERROR_NO_INTERFACE;
}
RefGrabIt.MIMEHandler.StreamListener.prototype.onDataAvailable = function(request, context, inputStream, offset, count) {
	if(inputStream != this._scriptableStreamInput) {
		this._scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"].
					             createInstance(Components.interfaces.nsIScriptableInputStream);
		this._scriptableStream.init(inputStream);
		this._scriptableStreamInput = inputStream;
	}
	this._readString += this._scriptableStream.read(count);
	//open window, create form, add login info and reference, DI.
	var sBaseUrl = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(sVersionPref+".").getCharPref("RequestUrl");
	sBaseUrl = sBaseUrl.replace(/refgrabit/gi,'refworks');
	var oForm = window._content.document.createElement('FORM');
	var sType = this._contentType == 'application/x-endnote-refer' ? 'Endnote View' : 'RIS Format';
	oForm.action = sBaseUrl + "/autologin.asp?filter="+sType+"&vendor=RefGrabIt";
	oForm.name = "ExportRWForm";
	oForm.target = "RefWorksMain";
    oForm.method = "POST";
	var oElement = null;
	try{
	oElement = window._content.document.createElement('INPUT');
	oElement.type = "hidden";
	oElement.name = "ImportData";
	oElement.value = this._readString;
	oForm.appendChild(oElement);
	}catch(e){}
	window._content.document.body.appendChild(oForm);
	oForm.submit();
}
RefGrabIt.MIMEHandler.StreamListener.prototype.onStartRequest = function(channel, context) {}
RefGrabIt.MIMEHandler.StreamListener.prototype.onStopRequest = function(channel, context, status) {}

RefGrabIt.inArray = function(contentType, desiredContentTypes){
	for(var i = 0; i < desiredContentTypes.length; i++)
		if(contentType.toLowerCase() == desiredContentTypes[i])
			return true;
	return false;
}

RefGrabIt.MIMEHandler.init = function(prefStatus) {
	if(!this.on && prefStatus) {
		Components.classes["@mozilla.org/uriloader;1"].getService(Components.interfaces.nsIURILoader).registerContentListener(RefGrabIt.MIMEHandler.URIContentListener);
		Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService).addObserver(RefGrabIt.MIMEHandler.Observer, "http-on-examine-response", false);
		this.on = true;
	} else if(this.on && !prefStatus) {
		Components.classes["@mozilla.org/uriloader;1"].getService(Components.interfaces.nsIURILoader).unRegisterContentListener(RefGrabIt.MIMEHandler.URIContentListener);
		Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService).removeObserver(RefGrabIt.MIMEHandler.Observer, "http-on-examine-response");
		this.on = false;			
	}
}